from practicum import McuBoard

RQ_SET_LED    = 0
RQ_GET_SWITCH_RIGHT = 1
RQ_GET_X  = 2
RQ_GET_SWITCH_LEFT = 3

####################################
class PeriBoard(McuBoard):
    def getSwitch_LEFT(self):
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
        if(self.usbRead(RQ_GET_SWITCH_LEFT)[0] == 1):
            return True
        else:
            return False

    #####################################

    ################################
    def setLed(self, led_no, led_val):
        '''
        Set status of LED led_no on peripheral board to led_val
        '''
        self.usbWrite(RQ_SET_LED, index=led_no, value=led_val)

    ################################
    def setLedValue(self, value):
        '''
        Display value's 3 LSBs on peripheral board's LEDs
        '''
        self.usbWrite(RQ_SET_LED, index=0, value=value%2)
        self.usbWrite(RQ_SET_LED, index=1, value=value/2%2)
        self.usbWrite(RQ_SET_LED, index=2, value=value/4%2)

    ################################
    def getSwitch(self):
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
        if(self.usbRead(RQ_GET_SWITCH_RIGHT)[0] == 1):
            return True
        else:
            return False

    ################################
    def getLight(self):
        '''
        Return the current reading of light sensor on peripheral board
        '''
        return self.usbRead(RQ_GET_LIGHT,length = 2)[0] + self.usbRead(RQ_GET_LIGHT,length = 2)[1]*256

    #######################################
    def get_X(self):
    	'''
        RETRUN SETA X_AXIS
        '''
        if self.usbRead(RQ_GET_X,length = 2)[1] > 100:
            #print -1*(255+(-1*self.usbRead(RQ_GET_X,length = 2)[0]))
            return -1*(255+(-1*self.usbRead(RQ_GET_X,length = 2)[0]))
        else :
            #print self.usbRead(RQ_GET_X,length = 2)[0]
            return self.usbRead(RQ_GET_X,length = 2)[0]
        #print self.usbRead(RQ_GET_X,length = 2)[0]
        #return self.usbRead(RQ_GET_X,length = 2)[0] + self.usbRead(RQ_GET_X,length = 2)[1]*256

		
